package com.brilliance.isc.funds.fxtfcm.check;

import com.brilliance.isc.common.transaction.newcheck.AbstractModuleValidator;
import com.brilliance.isc.common.transaction.newcheck.ValidResult;
import com.brilliance.isc.common.transaction.newcheck.Validate;
import com.brilliance.isc.funds.bo.funds.FxtfcmStoreBo;
import com.brilliance.isc.funds.bo.funds.FxtlopStoreBo;
import com.brilliance.mda.runtime.mda.util.MdaUtils;
import org.springframework.stereotype.Component;

import javax.annotation.PostConstruct;
import java.util.HashMap;
import java.util.Map;

/**
 * @program: isc-funds
 * @ClassName: FxtfcmValidator
 * @description: 结售汇平盘确认 Fxtfcm 校验
 * @author: 肖桐
 * @create: 2024-10-11 11:28
 */
@Component
public class FxtfcmValidator extends AbstractModuleValidator <FxtfcmStoreBo>{

    @Override
    @PostConstruct
    public void register(){
        super.register();;
    }

    @Override
    public Map<String, String> validate(FxtfcmStoreBo vo) {
        Map<String, String> maps = new HashMap<>();
        maps.putAll(super.validate(vo));
        return maps;
    }

    /**
     *   source:fxtfcm.0023.script
     */
    @Validate(path="fxdgrp.apl.pts.ref")
    public ValidResult checkFxdgrpAplPtsRefN1000(FxtfcmStoreBo vo){
        if( ! MdaUtils.isEmpty(vo.getSwtflg()) && ( MdaUtils.compareTo(vo.getMt30m().getS22a(),"AMND") == 0 || MdaUtils.compareTo(vo.getMt30m().getS22a(),"CANC") == 0 ) )
        {
            if( MdaUtils.isEmpty(vo.getFxdgrp().getApl().getPts().getRef()) )
            {
                return  errorMandatory();
            }
        }
        return null;
    }

    /**
     *   source:fxtfcm.0024.script
     */
    @Validate(path="mt30m.rbc.pts.extkey")
    public ValidResult checkMt30mRbcPtsExtkeyN1000(FxtfcmStoreBo vo){
        if( ! MdaUtils.isEmpty(vo.getSwtflg()) && MdaUtils.isEmpty(vo.getMt30m().getRbc().getPts().getExtkey()) )
        {
            return  errorMandatory();
        }
        return null;
    }

    /**
     *   source:fxtfcm.0025.script
     */
    @Validate(path="mt30m.owc.pts.extkey")
    public ValidResult checkMt30mOwcPtsExtkeyN1000(FxtfcmStoreBo vo){
        if( ! MdaUtils.isEmpty(vo.getSwtflg()) && MdaUtils.isEmpty(vo.getMt30m().getOwc().getPts().getExtkey()) )
        {
            return errorMandatory();
        }
        return null;
    }
}
