package com.brilliance.isc.funds.fxtsel.service.impl;

import com.brilliance.isc.bo.model.Fxdgrp;
import com.brilliance.isc.funds.common.component.FxToolComponent;
import com.brilliance.isc.common.util.StringUtils;
//import com.brilliance.isc.funds.bo.Fxdgrp;
import com.brilliance.isc.mda.dao.FxdMapper;
import com.brilliance.isc.vo.TrncodVo;
import com.brilliance.isc.vo.funds.FxtselQueryVo;
import com.brilliance.isc.vo.TrnCodeQueryVo;
import com.brilliance.isc.vo.funds.FxdWithPtsCbbResponseVo;
import com.brilliance.isc.funds.fxtsel.service.FxtselService;
import com.github.pagehelper.PageHelper;
import com.github.pagehelper.PageInfo;
import com.google.common.collect.ImmutableMap;
import com.google.common.collect.Lists;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.*;

@Service
public class FxtselServiceImpl implements FxtselService {

    private Logger logger = LoggerFactory.getLogger(FxtselServiceImpl.class);

    @Autowired
    private FxdMapper fxdMapper;

    @Autowired
    private FxToolComponent fxToolComponent;

    @Override
    public PageInfo list(FxtselQueryVo fxtselQueryVo) {
        PageHelper.startPage(fxtselQueryVo.getPageNumber(),fxtselQueryVo.getPageSize()).setReasonable(true);
        List<FxdWithPtsCbbResponseVo> fxdList = fxdMapper.queryFxd(fxtselQueryVo);
        return new PageInfo(fxdList);
    }

    @Override
    public PageInfo listdhpp(FxtselQueryVo fxtselQueryVo) {
        //FB+FS
        List<String> fxtypList=new ArrayList<>();
        fxtypList.add("FB");
        fxtypList.add("FS");
        fxtselQueryVo.setFxtypList(fxtypList);
        PageHelper.startPage(fxtselQueryVo.getPageNumber(),fxtselQueryVo.getPageSize()).setReasonable(true);
        List<FxdWithPtsCbbResponseVo> fxdList = fxdMapper.queryFxd(fxtselQueryVo);
        return new PageInfo(fxdList);
    }

    @Override
    public PageInfo listjsh(FxtselQueryVo fxtselQueryVo) {
        //FB+FS
        List<String> fxtypList=new ArrayList<>();
        fxtypList.add("SS");
        fxtypList.add("SB");
        fxtselQueryVo.setFxtypList(fxtypList);
        PageHelper.startPage(fxtselQueryVo.getPageNumber(),fxtselQueryVo.getPageSize()).setReasonable(true);
        List<FxdWithPtsCbbResponseVo> fxdList = fxdMapper.queryFxd(fxtselQueryVo);
        return new PageInfo(fxdList);
    }

    @Override
    public List<TrncodVo> dealWithByInr(TrnCodeQueryVo trnCodeQueryVo) {

        List<TrncodVo> result = Lists.newArrayList();
        Fxdgrp fxdgrp=new Fxdgrp();
        fxdgrp = fxToolComponent.getFxdgrpByInr(trnCodeQueryVo.getInr());

        String[] fxTraArray = {"FXTFCM", "FXTLCN"};
        String[] fxButArray = {"外币兑换平盘确认", "外币兑换平盘销账"};
        String isAllowed = "";
        for (int i = 0; i < fxTraArray.length; i++) {
            TrncodVo trncodVo = new TrncodVo(fxTraArray[i], fxButArray[i], isAllowed,"Y","");
            fxToolComponent.isFXTrnAllowed(fxdgrp,trncodVo);
            result.add(trncodVo);
        }
        return result;
    }
}
